package com.zipcodewilmington.phonebook;

import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;

//import static java.util.Map.*;
import java.util.*;

public class PhoneBook {

    private TreeMap<String, ArrayList<String>> treemp;

    public PhoneBook() {
        treemp = new TreeMap<String, ArrayList<String>>() ;
        //addInitialList();
    }

    public void setTreemp(String name, ArrayList phoneNumbers) {
         this.treemp.put(name, phoneNumbers);

    }

    public boolean hashEntry(String name) {

        if(treemp.containsKey(name))
        {
            return true;
        } else
        return false;
    }

    public void add(String name, String phoneNumber)
    {
        boolean keyExistsAlready = hashEntry (name);
        //Str str = "";
        //If key already exists then
        ArrayList<String> alOneTwoMany;
        if (keyExistsAlready) {
            // Add new Phonenumber to ArrayList of this Key
             alOneTwoMany = treemp.get(name);
            alOneTwoMany.add(phoneNumber);
            // Add the Arraylist back to the Key
            treemp.put(name, alOneTwoMany);
        } else {
            alOneTwoMany = new ArrayList<String>();
            alOneTwoMany.add(phoneNumber);
            treemp.put(name, alOneTwoMany);
        }
    }

    public int get (String key) {

        ArrayList al = treemp.get(key);
        return al.size();

    }


    /*public String lmeookup(String name) {

        String temp = treemp.get(name);
        return temp;
    }*/

    public void remove(String key, String number) {

        ArrayList alForRemove = treemp.get(key);

        /* For Loop for iterating ArrayList */
        for (int counter = 0; counter < alForRemove.size(); counter++) {
            if (alForRemove.get(counter).toString().equalsIgnoreCase(number)){
                alForRemove.remove(counter);
            }
        }
        // add the updated Arraylist back to Treemap
        treemp.put(key, alForRemove);
    }


    /* public void addInitialList () {

        this.setTreemp("Dog", "222-333-444");
        this.setTreemp("Yashoda","111-222-333");
        this.setTreemp("Zebra","222-4444-333");

    }

    public String reverseLookup (String phoneNumber ) {
        String key = "";
        for (Map.Entry<String, String> entry : treemp.entrySet()) {
            if (entry.getValue().equals(phoneNumber)) {
                key = entry.getKey();
            }
        }
        return key;
    }

    public String listNamesAndNumbers ( ) {

        StringBuffer sb = new StringBuffer();

        for (Map.Entry<String, String> entry : treemp.entrySet()) {


            sb.append(entry.getKey()) ;
            sb.append(" ");
            sb.append(entry.getValue());
            sb.append("\n");
            }
        return sb.toString();

    }
*/
    public void removeRecord (String key) {
        treemp.remove(key);
    }

    public int getNoOfRecords (){
        return treemp.size();
    }


}

